# Tutorial APAP
## Authors
> **Muhammad Raihan Adliputra** - *2006485680* - *A*


## Tutorial 4
### Pertanyaan
1. Jelaskan perbedaan th:include dan th:replace!<br />
* **th:include**  memungkinkan kita untuk memasukkan code yang kita fragment ke dalam tag div agar nantinya konten yang ada dalam fragment juga ditampilkan.
* **th:replace** akan digunakan untuk mengubah host tag dengan isi konten yang ada pada fragment.

2. Jelaskan apa fungsi dari th:object! <br />
**th:object** berfungsi untuk menspesifikasikan suatu objek yang akan kita *submit* pada suatu *form*. Biasanya akan digunakan ketika menggunakan method POST dan setelah itu diiringi dengan **th:action**.

3. Jelaskan perbedaan dari * dan $ pada saat penggunaan th:object! Kapan harus dipakai?<br />
* *{} merupakan sebuah ekspresi dari sebuah variabel yang akan dipakai ketika ingin mengevaluasi suatu objek yang sudah didefinisikan pada controller.
* ${} merupakan sebuah ekspresi dari sebuah variabel yang akan dipakai ketika ingin mengevaluasi secara utuh suatu objek atau atribut.

## Tutorial 3
### What I have learned today
* Saya baru mengetahui bahwa mengetik isi dari class akan lebih cepat dari mengetik import terlebih dahulu
### Pertanyaan
1. Tolong jelaskan secara singkat apa kegunaan dari anotasi-anotasi yang ada pada model (@AllArgsConstructor, @NoArgsConstructor, @Setter, @Getter, @Entity, @Table) <br />
* **@AllArgsConstructor** berfungsi untuk membuat *constructor* yang nantinya akan membutuhkan argumen pada *class*.
* **@NoArgsConstructor** berfungsi untuk men-*generate constructor* kosong.
* **@Setter** berfungsi untuk men-*generate* fungsi *setter*.
* **@Getter** berfungsi untuk men-*generate* fungsi *getter*.
* **@Entity** berfungsi untuk mendefinisikan kelas yang ada berkorelasi dengan tabel pada *database*.
* **@Table** berfungsi untuk mendefinisikan nama tabel *database* yang akan digunakan.

2. Pada class CourseDb, terdapat method findByCodeUsingQuery dan findByCode, apakah perbedaan kedua method tersebut? Jelaskan juga kegunaan @Query pada method findByCodeUsingQuery! <br />
* Method **findByCodeUsingQuery** berfungsi untuk mencari Objek Course yang sesuai dengan codenya menggunakan Query.
* Method **findByCode** berfungsi untuk mencari Objek Course yang sesuai dengan codenya menggunakan method bawaan dari JPA Repository.
<br /><br />
**@Query** digunakan agar kita bisa menjalankan query sql untuk mencari code yang sesuai dari Course yang ingin kita lihat pada tabel relasi yang sudah kita buat. Atau dalam kata lain method tersebut digunakan untuk meng-*execute* JPQL dan *query native* dari SQL nya.

3. Jelaskan perbedaan kegunaan dari anotasi @JoinTable dan @JoinColumn <br />
* **@JoinColumn** berfungsi untuk membuat sebuah kolom baru pada *database* yang ada dan kolom tersebut digunakan untuk merefer kolom lain menggunakan *foreign key*.
* **@JoinTable** berfungsi untuk membuat pemetaan asosiasi-asosiasi seperti **many-to-many**, **many-to-one**, dan lainnya kedalam tabel *database*.

4. Pada class Pengajar, digunakan anotasi @JoinColumn pada atribut Course, apa kegunaan dari name, referencedColumnName, dan nullable dalam anotasi tersebut? dan apa perbedaan nullable dan penggunaan anotasi @NotNull <br />
* **referencedColumName** adalah sebuah kolom yang akan dirujuk dari kolom lain yang merupakan *doreign key*.
* **name** adalah nama kolom suatu *entity*.
* **nullable** digunakan untuk mencegah adanya data yang bersifat null pada *database*.
* Perbedaan antara **nullable** dan anotasi **@NotNull** adalah **nullable** menunjukkan status dari null tersebut, sementara **@NotNull** digunakan untuk mencegah adanya data yang null untuk masuk kedalam *database*.

5. Jelaskan kegunaan FetchType.LAZY, CascadeType.ALL, dan FetchType.EAGER <br />
* **FetchType.Lazy** digunakan untuk mengakses sebuah atribut yang saat dibutuhkan.
* **CascadeType.ALL** digunakan untuk mengambil atribut yang berelasi ketika *parent entity* diambil.
* **FetchType.EAGER** digunakan untuk menyebarkan operasi seperti **PERSIST**, **REMOVE**, **REFRESH**, **MERGE**, dan lainnya ke entitas yang terkait.

## Tutorial 2
### What I have learned today
* Saya berhasil mencoba dan memahami materi Organizing Domain Logic & Service Layer
### Pertanyaan
1. Cobalah untuk menambahkan sebuah Course dengan mengakses link berikut:
[Sebuah Link](http://localhost:8080/course/add?code=APAP&nameCourse=APAP%20Tutorial2&description=2020%20Fasilkom&jumlahSks=3)
Apa yang terjadi? Jelaskan mengapa hal tersebut dapat terjadi! <br />
Akan terjadi **Whitelabel Error**. *Error* ini akan terjadi karena file *controller* akan mencoba mengakses file html yang tidak tersedia, yaitu ketika file *controller* mengembalikan *string* nama file html yang dimana file html tersebut belum tersedia pada folder *template*.

2. Menurut kamu anotasi @Autowired pada class Controller tersebut merupakan implementasi dari konsep apa? Dan jelaskan secara singkat cara kerja @Autowired tersebut dalam konteks service dan controller yang telah kamu buat <br />
Anotasi **@Autowired** pada file *controller* adalah contoh implementasi dari *Dependency Injection*, yaitu sebuah fitur yang membuat Spring bisa menyelesaikan dan menyuntikkan *beans* yang berkolaborasi dengan *beans* lainnya.
*Reference*: 
> [Dependency Injection](https://www.baeldung.com/spring-autowire)   

3. Cobalah untuk menambahkan sebuah Course dengan mengakses link berikut: <br />
[Sebuah Link](http://localhost:8080/course/add?code=APAP&nameCourse=APAP%20Tutorial2&jumlahSks=3)   
Apa yang terjadi? Jelaskan mengapa hal tersebut dapat terjadi! <br />
Akan terjadi **Whitelabel Error**. *Error* ini akan terjadi karena method *addCourse* membutuhkan sebuah parameter description untuk menambahkan sebuah course ke dalam *listCourse*, sementara parameter yang dibutuhkan tidak ada.

4. Jika Papa APAP ingin melihat Course dengan kode APAP, link apa yang harus diakses? <br />
Link yang dapat diakses oleh Papa APAP adalah sebagai berikut:
* [Link 1](http://localhost:8080/course/view?code=APAP) yang akan menggunakan *RequestParam*.
* [Link 2](http://localhost:8080/course/view/code-course/APAP) yang akan menggunakan *PathVariable*.
Papap APAP bisa mengakses link tersebut karena kedua link itu akan mengarahkan user untuk mampu melihat detail course apapun dengan kode spesifik yang harus dimasukkan.

5. Tambahkan 1 contoh Course lainnya sesukamu. Lalu cobalah untuk mengakses > [Sebuah Link](http://localhost:8080/course/viewAll), apa yang akan ditampilkan? Sertakan juga bukti screenshotmu. <br />
Yang akan ditampilkan adalah detail seluruh course yang akan menampilkan:
* **Code**
* **Nama Course**
* **Description**
* **Jumlah Sks** <br />
Untuk contoh course yang akan saya tambahkan adalah (bukti penambahan bisa diakses melalui link ini [Link Bukti](https://drive.google.com/drive/folders/1tb_SLx-8CEpsnoSTjrp1CxaT7i4lYolL?usp=sharing)): <br />
* Kode = **SOSI**
* Nama Course = **APAP Tutorial2**
* Description = **2020 Fasilkom**
* Jumlah Sks = **3**

## Tutorial 1
### What I have learned today
* Saya berhasil mencoba *hands on* membuat program BMI sederhana menggunakan Spring Boot
* Saya berhasil mengingat dan mengoperasikan kembali *command-command* pada penggunaan GitLab
### GitLab
1. Apa itu Issue Tracker? Apa saja masalah yang dapat diselesaikan dengan Issue Tracker? <br />
**Issue Tracker**, merupakan fitur yang ada pada GitHub yang berfungsi untuk memudahkan *user* untuk tetap *on track* dan mengerahui perubahan apa saja yang terjadi pada proyek. Selain itu, **Issue Tracker** juga bisa membantu *user* untuk menemukan bug yang ada pada proyek.
*Reference*:
> [About issues](https://docs.github.com/en/issues/tracking-your-work-with-issues/about-issues)

2. Apa perbedaan dari git merge dan git merge --squash? <br />
*command* `git merge --squash` akan menyatukan semua commit pada suatu branch menjadi 1 commit saja. Sehingga, jika *user* ingin melakukan merge ke branch main, maka branch tersebut hanya memberikan 1 commit.
*Reference*:
> [git merge VS git merge -- squash](https://monsterlessons-academy.com/p/git-squash-how-to-combine-git-commits-with-merge-and-rebase)

3. Apa keunggulan menggunakan Version Control System seperti Git dalam pengembangan suatu aplikasi? <br />
Fungsi dari **Version Control System** adalah menyimpan perubahan pada *source code*, sehingga mampu meminimalisir resiko gagal ada kode yang sudah kita ubah.
*Reference*:
> [Version Control System](https://glints.com/id/lowongan/version-control-system/#.YTjZGp0zaUk)
### Spring
4. Apa itu library & dependency? <br />
* **Library** merupakan kumpulan code pada sebuah modul yang bisa dipakai oleh *user* untuk memudahkan pembuatan suatu proyek.
* **Dependency** merupakan sebuah kata yang mereferensikan ketika suatu *software* saling berkaitan dengan *software* lainnya.
*Reference*:
> [Library](https://id.quora.com/Apa-yang-dimaksud-dengan-library-pada-pemrograman)
> [Dependency](https://coderslegacy.com/what-are-dependencies-in-programming/)

5. Apa itu Gradle? Mengapa kita menggunakan Gradle? Apakah ada alternatif dari Gradle? <br />
**Gradle** merupakan *automation tool* untuk membangun *software*. **Gradle** kita gunakan karena **Gradle** mampu memberikan performa yang sangat baik dan juga **Gradle** saat ini sudah bisa dipakai oleh *user* di berbagai macam IDE yang ada di pasar saat ini. Alternatif lain dari penggunaan **Gradle** adalah Maven, Bazel, dan lainnya.
*Reference*:
> [About Gradle](https://www.simplilearn.com/tutorials/gradle-tutorial/what-is-gradle)
> [Gradle altenatives](https://rigorousthemes.com/blog/best-gradle-alternatives/)

6. Selain untuk pengembangan web, apa saja yang bisa dikembangkan dengan Spring framework? <br />
**Spring framewor** dapat digunakan untuk Cloud, Reactive, Event Driven, dan sebagainya.
*Reference*:
> [Spring framework](https://spring.io/projects/spring-framework)

7. Apa perbedaan dari @RequestParam dan @PathVariable? Kapan sebaiknya menggunakan @RequestParam atau @PathVariable? <br />
* **@RequestParam** digunakan untuk mengakses nilai dari parameter.
* **@PathVariable** digunakan untuk mengakses nilai dari template URI.
*Reference*:
> [RequestParam VS PathVariable](https://javabeat.net/spring-mvc-requestparam-pathvariable/)
### What I did not understand
Saya masih belum terbiasa dengan sistem branch pada gitlab, karena selama ini saya hanya menggunakan branch main pada gitlab. Saya juga baru pertama kali menggunakan spring boot, sehingga saya masih tidak mengerti apa yang saya ketikkan pada kode yang ada pada Tutorial 1 ini.
- [x] Apakah saya mampu lulus APAP dengan nilai memuaskan?
**YA**. Karena saya mampu dan saya ingin.
